
from flask import Blueprint, request, jsonify,session
from manager.serverCenter import server,emailserver
from model.Model import User,Emails
import base64
import requests
from bs4 import BeautifulSoup
from manager.tools import sqlOrmToJson

db=server.db
tool = Blueprint("tools", __name__, url_prefix='/tool')
jiraAddress="http://jira.galaxy-immi.com"

def getheader(id_):
    result=db.session.query(User.jira_account,User.jira_password).filter_by(id=id_).first()
    db.session.close()
    if not result.jira_account and not result.jira_password:
        return
    headers={
        "Authorization":"Basic "+base64.b64encode((result.jira_account+":"+result.jira_password).encode('utf-8')).decode(),
        "accept":"application/json,text/javascript,*/*;q=0.01"
    }
    return headers

# def sendEmail(to,subject,contents=None,attachments=None):
#     '''
#     to 发送目标，数组时为多人
#     subject 主题
#     contents 内容
#     attachments 附件，数组时为多个
#     '''
#     emailserver.server.send(to=to,subject=subject,contents=contents,attachments=attachments)
    
@tool.route('/testport/sendport', methods=["POST"])
def sendport():
    import yagmail
    data=request.json
    user = 'wallen.ywh@galaxyoversea.com'
    password = 'Ywh940509'
    yag = yagmail.SMTP( user=user, password=password, host='smtp.exmail.qq.com',port=465)
    print(emailserver.server.__dict__)
    # emailserver.server.send(data["to"],data.get("subject"),data.get("contents"))
    yag.send(data["to"],data.get("subject"),data.get("contents"))
    return jsonify({"code": 200, "message": "请求成功"}),200
    
@tool.route('/testport/getproject', methods=["GET"])
def getproject():
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    result=requests.request("get",jiraAddress+"/rest/api/1.0/menus/browse_link?inAdminMode=false",headers=headers).json()
    # return jsonify({"code": 200, "message": "请求成功", "data": result}),200
    res=[]
    for each in result["sections"]:
        if each.get("title")=="当前活动的项目" or each.get("title")=="您最近参与的项目":
            for ele in each["items"]:
                res.append({"key":ele["url"].split("/")[-1],"name":ele["label"]})
    if res:
        return jsonify({"code": 200, "message": "请求成功", "data": res}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/iteration/<getproject>', methods=["GET"])
def iteration(getproject):
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    print(requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+getproject,headers=headers).json())
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+getproject,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+getproject,headers=headers).json()
    res=[]
    for each in result["sprints"]:
        res.append({"key":each["id"],"name":each["name"]})
    if res:
        return jsonify({"code": 200, "message": "请求成功", "data": res}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/reportinfo', methods=["GET"])
def reportinfo():
    project=request.args.get("project")
    iteration=request.args.get("iteration")
    headers=getheader(session.get("id"))
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+project,headers=headers).json()
    all_=result.get("issues")
    status={}
    for k,v in result["entityData"]["statuses"].items():
        status[k]=v["statusName"]
    priority={}
    for k,v in result["entityData"]["priorities"].items():
        priority[k]=v["priorityName"]
    type_={}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
        
    spList=[]
    sprint=None
    for i in result["sprints"]:
       if i["id"]==int(iteration):
           spList=i["issuesIds"]
           sprint=i["name"]
           break
    #    x:type_[x["typeId"]]=="测试用例"
    iterationitems=list(filter(lambda x:x["id"] in spList,all_))
    peoples={'test':[],'qian':[],'hou':[],'chan':[]}
    story=list(filter(lambda x:type_[x["typeId"]]=="Story",iterationitems))
    bug=list(filter(lambda x:type_[x["typeId"]]=="BUG",iterationitems))
    testcase=list(filter(lambda x:type_[x["typeId"]]=="测试用例",all_))
    for i in story:
        i["case"]=[]
        i["childrenTask"]=[i.get("key")]
        chan=i["extraFields"][0]["html"]
        if chan not in peoples["chan"]:
            peoples["chan"].append(chan)
        i["peoples"]=[chan]
        info=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/issue/details.json?rapidViewId="+str(id_)+"&issueIdOrKey="+i["key"]+"&loadSubtasks=true",headers=headers).json()
        for j in info.get("tabs").get("defaultTabs"):
            if j.get("tabId")=="SUB_TASKS":
                for m in j.get("subtaskEntries"):
                    k=None
                    if m.get("assignee"):
                        k=m.get("assignee").get("displayName")
                        if k not in i["peoples"]:
                            i["peoples"].append(k)
                    if (("测试" in m.get("summary") or "用例" in m.get("summary")) and k and k not in peoples["test"]) :    
                        peoples["test"].append(k) 
                    elif "前端" in m.get("summary") and k and k not in peoples["qian"]:
                        peoples["qian"].append(k) 
                    elif "后端" in m.get("summary") and k and k not in peoples["hou"]:
                        peoples["hou"].append(k)
                    i["childrenTask"].append(m.get("key"))
            elif j.get("tabId")=="THIRD_PARTY_TAB":
                for each in j.get("sections"):
                    if each["label"]=="测试用例":
                        soup=BeautifulSoup(each["html"],"html.parser")
                        i["case"]=[i.next_element for i in soup.select('tr>td[align="left"]>span>a')]
    
    res={"project":result["projects"][0]["name"],"sprint":sprint,"people":peoples,"story":story,"bug":bug,"testcase":testcase,"statusMap":status,"priorityMap":priority,"typeMap":type_}
    return jsonify({"code": 200, "message": "请求成功", "data": res}),200 


@tool.route('/testport/addemailuser', methods=["POST"])
def addemailuser():
    data=request.json
    addinfo=Emails(name=data.get("name"),address=data.get("address"))
    db.session.add(addinfo)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/deleteemailuser/<id_>', methods=["DELETE"])
def deleteemailuser(id_):
    db.session.query(Emails).filter_by(id=id_).delete()
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/emailuserlist', methods=["GET"])
def emailuserlist():
    data=db.session.query(Emails.id,Emails.name,Emails.address).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data": sqlOrmToJson(data)}),200

@tool.route('/testport/editemailuser', methods=["POST"])
def editemailuser():
    db.session.query(Emails).filter_by(id=request.json.get("id")).update({"name":request.json.get("name"),"address":request.json.get("address")})
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200
    
